<template>
  <main>
    <mt-controle-activites
      :type-activite-selected="typeActiviteSelected"
      :is-my-activities="isMyActivities"
      :date-courante="moisCourant"
      @filtrer-type-activite="filtrerTypeActivite"
      @filtrer-my-activities="filtrerMyActivities"
    />
    <mt-box-activites :date-courante="moisCourant" @mois-selectionne="moisSelectionne">
      <template #recherche>
        <b-input
          v-model="filtre"
          class="mt-auto-complete-border-less"
          placeholder="Rechercher une activité"
          type="search"
          icon="magnify"
          clearable
          @input="refreshSearch"
        >
        </b-input>
      </template>
      <mt-table-activities class="mt-table-activites" :activites="activites" />
    </mt-box-activites>
  </main>
</template>

<script>
import debounce from 'lodash/debounce';
import { DateTime } from 'luxon';
import MtTableActivities from '~/components/activity/table-activities';
import MtBoxActivites from '~/components/activity/box-activites';
import MtControleActivites from '~/components/activity/controle-activites';
import userMixin from '~/components/mixins/userMixin';

export default {
  components: {
    MtTableActivities,
    MtControleActivites,
    MtBoxActivites,
  },
  mixins: [userMixin],
  data() {
    return {
      typeActiviteSelected: [],
      isMyActivities: false,
    };
  },
  watch: {
    organisme: {
      handler() {
        this.refresh();
      },
      immediate: true,
    },
  },
  watchQuery: ['mois'],
  async asyncData({ $api, store, query }) {
    const moisCourant = query && query.mois ? DateTime.fromFormat(query.mois, 'yyyy-MM').toJSDate() : new Date();
    const isEmploye = store.getters['context/isEmploye'];
    const start = DateTime.fromJSDate(moisCourant).startOf('month');
    const end = DateTime.fromJSDate(moisCourant).endOf('month');
    const filtre = '';
    let activitesReq = null;
    if (isEmploye) {
      activitesReq = $api.utilisateur().activitesEntre(start.toISO(), end.toISO());
    } else {
      activitesReq = $api.organisme().activitesEntre(start.toISO(), end.toISO());
    }

    const activites = await activitesReq;

    return {
      activites,
      moisCourant,
      ouvertDelete: false,
      filtre,
    };
  },
  methods: {
    async moisSelectionne({ startDate }) {
      const isEmploye = this.$store.getters['context/isEmploye'];
      let activitesReq = null;

      const start = DateTime.fromJSDate(startDate).startOf('month');
      const end = DateTime.fromJSDate(startDate).endOf('month');

      if (isEmploye) {
        activitesReq = this.$api
          .utilisateur()
          .activitesEntre(start.toISO(), end.toISO(), this.typeActiviteSelected, this.isMyActivities, this.filtre);
      } else {
        activitesReq = this.$api
          .organisme()
          .activitesEntre(start.toISO(), end.toISO(), this.typeActiviteSelected, this.filtre);
      }
      this.activites = await activitesReq;
      this.moisCourant = startDate;
      await this.$router.replace({
        query: { mois: DateTime.fromJSDate(startDate).toFormat('yyyy-MM') },
      });
    },
    refreshSearch: debounce(async function refresh() {
      await this.refresh();
    }, 500),
    async refresh() {
      const isEmploye = this.$store.getters['context/isEmploye'];
      const start = DateTime.fromJSDate(this.moisCourant).startOf('month');
      const end = DateTime.fromJSDate(this.moisCourant).endOf('month');

      let activitesReq = null;
      if (isEmploye) {
        activitesReq = this.$api
          .utilisateur()
          .activitesEntre(start.toISO(), end.toISO(), this.typeActiviteSelected, this.isMyActivities, this.filtre);
      } else {
        activitesReq = this.$api
          .organisme()
          .activitesEntre(start.toISO(), end.toISO(), this.typeActiviteSelected, this.filtre);
      }
      this.activites = await activitesReq;
    },
    filtrerTypeActivite(newValue) {
      this.typeActiviteSelected = newValue;
      this.refresh();
    },
    filtrerMyActivities(newValue) {
      this.isMyActivities = newValue;
      this.refresh();
    },
  },
};
</script>

<style scoped lang="scss">
@import '~/assets/css/_variables';
.mt-table-activites {
  padding: 0 4rem 3rem 4rem;
  @include mobile {
    padding: 1rem 0;
  }
}
</style>
